import sys

params = sys.argv
if len(params)<3:
	print "usage: assignLib2War.py <libName> <earName> <warName>"
	sys.exit(1)

libName = params[0];
appName = params[1];
warName = params[2];

library = AdminConfig.getid('/Library:'+libName+'/')
app = AdminConfig.getid('/Deployment:'+appName+'/')
webModules = AdminConfig.list("WebModuleDeployment", app) 
wmList = webModules.split(lineSeparator)

foundWar = 0 

for webModule in wmList: 
	uri = AdminConfig.showAttribute(webModule, "uri") 
	if uri == warName+".war": 
		print "Found " + uri
		#modify the classloader for this .war 
		cl = AdminConfig.list("Classloader", webModule) 
		#check if classloader exists 
		if len(cl) == 0:
			print "Error: no classloader exists, you need to create it first"
			sys.exit(1)
		print "Assigning " + libName
		print AdminConfig.create('LibraryRef', cl, [['libraryName', libName],  ['sharedClassloader', 'true']])
		AdminConfig.save()
		foundWar = 1
		break

if foundWar == 0:
	print "WAR " + warName + ".war not found"

print "Done."

