params = sys.argv
# print "received: "+params[0]+", "+params[1]+", "+params[2]

if len(params)<7:
  print "usage: configureDS.py <providerName> <dataSourceName> <dbName> <serverName> <portNumber> <driverType> <jndiName>"
  sys.exit(1)

providerName = params[0];
dsName = params[1];
dbName = params[2];
serverName = params[3];
portNumber = params[4];
driverType = params[5];
jndiName = params[6];

cell_name = AdminControl.getCell();
node_name = AdminControl.getNode();
node=AdminConfig.getid('/Cell:'+cell_name+'/Node:'+node_name);

n1 = ['name', providerName]
implCN = ['implementationClassName', 'com.ibm.db2.jcc.DB2ConnectionPoolDataSource']
jdbcAttrs = [n1, implCN]
newjdbc = AdminConfig.create('JDBCProvider', node, jdbcAttrs)

# newjdbc = AdminConfig.getid('/Cell:'+cell_name+'/Node:'+node_name+'/JDBCProvider:'+providerName+'/')
if not newjdbc:
  print "Can not create provider"
  sys.exit(1)

nameAttr = ['name', dsName]
jndiNameAttr = ['jndiName', jndiName]
dsAttrs = [nameAttr, jndiNameAttr]

newDS = AdminConfig.create('DataSource', newjdbc, dsAttrs)
print newDS

propSet = AdminConfig.showAttribute(newDS, 'propertySet')
if not propSet:
  print "Can not get DataSource properties. Creating new set."
  propSet = AdminConfig.create('J2EEResourcePropertySet', newDS, [])
  # sys.exit(1)

nameAttr  = ['name', 'factory']
valueAttr = ['value', 'com.ibm.db2.jcc.DB2DataSourceFactory']
propAttrs = [nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

nameAttr  = ['name', 'factory']
valueAttr = ['value', 'com.ibm.db2.jcc.DB2DataSourceFactory']
propAttrs = [nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

nameAttr  = ['name', 'driverClassName']
valueAttr = ['value', 'com.ibm.db2.jcc.DB2Driver']
propAttrs = [nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

nameAttr  = ['name', 'databaseName']
valueAttr = ['value', dbName]
propAttrs = [ nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

nameAttr  = ['name', 'serverName']
valueAttr = ['value', serverName]
propAttrs = [ nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

nameAttr  = ['name', 'portNumber']
valueAttr = ['value', portNumber]
propAttrs = [ nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

nameAttr  = ['name', 'driverType']
valueAttr = ['value', driverType]
propAttrs = [ nameAttr, valueAttr]
AdminConfig.create('J2EEResourceProperty', propSet, propAttrs)

AdminConfig.save()


