import sys

debugMode = 0

def debug(paramName, value):
  if debugMode:
    print "----------- " + paramName + " ---------"
    print value
    print AdminConfig.show(value)

def configAuth(userName, hostName, port):
  cells = AdminConfig.list("Cell")
  cell = cells.split("\r\n")[0]

  secObjects = AdminConfig.list("Security", cell)
  secObject = secObjects.split("\r\n")[0]

  registryList = AdminConfig.showAttribute(secObject, "userRegistries")
  localUserReg = ""
  if len(registryList) != 0:
    registryLength = len(registryList) - 1
    registries =  registryList[1:registryLength].split(" ")
    for reg in registries:
      if reg.find("LDAPUserRegistry") != -1:
        localUserReg = reg
        break
    if localUserReg == "":
      print "Cannot find local OS user registry."
      sys.exit(1)
  else:
    print "Cannot find user registries"
    sys.exit(1)

  searchFilters = AdminConfig.showAttribute(localUserReg, "searchFilter")
  searchFilter = searchFilters.split()[0]
  attrs = [["userFilter", "(&(uid=%v)(objectclass=inetOrgPerson))"]]
  AdminConfig.modify(searchFilter, attrs)

  hosts = AdminConfig.showAttribute(localUserReg, "hosts")
  host = hosts[1:len(hosts)-1].split(" ")[0]
  attrs = [["host", hostName], ["port", port]]
  AdminConfig.modify(host, attrs)

  attrs = [["type", "CUSTOM"], ["realm", hostName+":"+port], ["useRegistryServerId", "false"], ["primaryAdminId", userName]]
  AdminConfig.modify(localUserReg, attrs)

  attrs = [["issuePermissionWarning", "false"], ["activeUserRegistry", localUserReg], ["enabled", "true"]]
  AdminConfig.modify(secObject, attrs)
  if not debugMode:
    AdminConfig.save()
#end def
  
  
#-----------------------------------------------------------------------------
# Main entry point
#-----------------------------------------------------------------------------

params = sys.argv[0].split()
i = 0
while i < len(params):
  if params[i] == "-user":
    user = params[i+1]
    i = i + 1
  elif params[i] == "-host":
    host = params[i+1]
    i = i + 1
  elif params[i] == "-port":
    port = params[i+1]
    i = i + 1
  i = i + 1


configAuth(userName=user, hostName=host, port=port)
