/// db2viper.src.gml - Licensed Materials ­ Property of IBM
/// db2viper.src.gml - 5724-S67
/// db2viper.src.gml - © Copyright IBM Corp. 1998, 2007   All Rights Reserved.
/// db2viper.src.gml - US Government Users Restricted Right ­ Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
/// db2viper.gml
key ObjectRefKey(objecttype,objectpath,objectname)
key OriginRefKey(platformtype,platformname) 
key PlatformRefKey(platformtype,platformname)
key TargetRefKey(platformtype,platformname)
key SourceRefKey(logonname)
key StreamRefKey(description)

key SourceAspectKey(originator,instancename,rolename)

key ObjectAspectKey(path,condition,object_type,origtype,object_focus)
key EventDetailRefKey(category,audit_event,nodeid,attempt,grantee_type,privilege,eventdetail,reason,access_type)

/// AUDIT

initial state AUDIT 
((    (category eq "AUDIT")    
      and (eventmainclass ne "Unavailable")
      and (eventclass ne "Unavailable")
))

    eventmainclass := AUDIT.eventmainclass
    eventclass := AUDIT.eventclass

    if(AUDIT.event_status >= "0")
    then
        successclass := "Success"
    else
        successclass := "Failure"
    endif

    eventsourcetype := Trim(GetChunkProperty(AUDIT,"auditedmachinetype"), "Unavailable")
    platformname  := Trim(GetChunkProperty(AUDIT,"SystemName"), "Unavailable")

    case eventsourcetype of
        "13":
            platformtype := "IBM DB2 9.5 on Windows"
            instance_name := Trim(GetChunkProperty(AUDIT,"Option5"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(AUDIT,"Option1"),"Unavailable")
            inst_patt := Trim(GetChunkProperty(AUDIT,"Option2"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(AUDIT,"Option3"),"Unavailable")
            db_patt := Trim(GetChunkProperty(AUDIT,"Option4"),"Unavailable")
            configpath := Append(instance_name,"\\","security")
        "11":
            platformtype := "IBM DB2 9.5 on AIX"
            instance_name  := Trim(GetChunkProperty(AUDIT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(AUDIT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(AUDIT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(AUDIT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(AUDIT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "14":
            platformtype := "IBM DB2 9.5 on SUN"
            instance_name  := Trim(GetChunkProperty(AUDIT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(AUDIT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(AUDIT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(AUDIT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(AUDIT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "10":
            platformtype := "IBM DB2 9.5 on HP-UX"
            instance_name  := Trim(GetChunkProperty(AUDIT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(AUDIT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(AUDIT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(AUDIT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(AUDIT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "16":
            platformtype := "IBM DB2 9.5 on Linux"
            instance_name  := Trim(GetChunkProperty(AUDIT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(AUDIT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(AUDIT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(AUDIT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(AUDIT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        otherwise
            platformtype := "IBM DB2 9.5"
            instance_name  := Trim(GetChunkProperty(AUDIT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(AUDIT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(AUDIT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(AUDIT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(AUDIT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
    endcase

    database_name  := Trim(AUDIT.database, "Unavailable")
    case AUDIT.objecttype of
    "GETDBINST":
        if (database_name eq "Unavailable")
            then
              objecttype := "DBINSTANSE"
              objectpath := "-"
              objectname := instance_name
            else
              objecttype := "DATABASE"
              objectpath := instance_name
              objectname := database_name
        endif
    "GETPOLT":
              objecttype := AUDIT.policyobjtype
              objectname := AUDIT.policyobjname
                if (database_name eq "Unavailable")
                    then
                      objectpath := instance_name
                    else
                        case AUDIT.policyobjtype of
                        "DBVIEW":
                            objectpath := Append(instance_name, " / ", database_name)
                        "DBTABLE":
                            objectpath := Append(instance_name, " / ", database_name)
                        otherwise
                            objectpath := instance_name
                        endcase
                endif
                if AUDIT.aspect_policyname ne ""  then  object_focus := AUDIT.aspect_policyname endif
    otherwise
        objecttype := AUDIT.objecttype
        objectpath := Trim(AUDIT.objectpath, "-")
        objectname := database_name
    endcase

    case AUDIT.objectname of
    "DATABASE":
    if (database_name eq "Unavailable")
            then
                objectpath := "-"
                objectname := instance_name
            else
                objectpath := instance_name
                objectname := database_name
    endif
    "INSTNAME":
        objectname := instance_name
    endcase

    case AUDIT.object_cond of
    "o2":
                objectpath := configpath
                objectname := AUDIT.objectname
    "o3":
        if (database_name eq "Unavailable")
            then
              objectpath := inst_archpath
              objectname := inst_patt
            else
              objectpath := db_archpath
              objectname := db_patt
        endif
    "o4":

        path := db_archpath
        condition := "logs associated with database and present in path"
    endcase

    object       := GetObject(ObjectRefKey,ObjectAspectKey)    
    origin       := GetOrigin(OriginRefKey)
    platform     := GetPlatform(PlatformRefKey)
    target       := GetTarget(TargetRefKey)

    user_id      := Trim(AUDIT.user_id, "Unavailable")

    if (RegexMatch(user_id,"(.+)\\s$") > "0") then
        user_id      := RegexRef("1")
    endif
    auth_id      := Trim(AUDIT.auth_id, "Unavailable")

    if (auth_id eq "Unavailable")
    then
    auth_id := user_id
    endif

    case eventsourcetype of
        "13":
            logonname  := Uppercase(auth_id)
            realname   := Uppercase(user_id)
            domainname := Trim(GetChunkProperty(AUDIT,"_domain"), "Unavailable")
            domainlogonname  := Uppercase(Append(domainname, "\\", auth_id))
            orig := GetOriginator(domainlogonname,"ND")

            if (orig eq "ND")
            then
                originator := user_id
            else
                originator := orig
                logonname := domainlogonname
            endif
        otherwise
            logonname  := user_id
            realname   := user_id
            rolename   := Uppercase(user_id)
            orig := GetOriginator(logonname,"ND")
            if (orig eq "ND")
            then
                originator := logonname
            else
                originator := orig
            endif
    endcase

    instancename := instance_name
    source     := GetSource(SourceRefKey, SourceAspectKey)
    description := logonname
    stream      := GetStream(StreamRefKey)

    chunk := AUDIT
    eventtimestamp := AUDIT.platformeventtime
/// category,audit_event,nodeid,user_id,attempt,object_type,grantee_type,privilege    
    if AUDIT.category ne ""  then  category := AUDIT.category endif
    if AUDIT.audit_event ne ""  then  audit_event := AUDIT.audit_event endif
    if AUDIT.nodeid ne ""  then  nodeid := AUDIT.nodeid endif

    event := GetEvent(EventDetailRefKey)

endstate

/// CHECKING

initial final state CHECKING 
((    (category eq "CHECKING")    
      and (eventmainclass ne "Unavailable")
      and (eventclass ne "Unavailable")
))

     case CHECKING.eventmainclasscheck of
        "c1":
            if CHECKING.action eq "CHECKING_TRANSFER"
                then
                    eventmainclass := Append(Inspect,Lowercase(CHECKING.eventmainclass))
                    privilege := Uppercase(CHECKING.eventmainclass)
                else
                    eventmainclass := CHECKING.eventmainclass                
            endif
        "c2":
            eventmainclass := CHECKING.eventmainclass
            path := db_archpath
            condition := "logs associated with database and present in path"
        otherwise
            eventmainclass := CHECKING.eventmainclass
     endcase

     eventclass := CHECKING.eventclass

    if(CHECKING.event_status >= "0")
    then
        successclass := "Success"
    else
        successclass := "Failure"
    endif

    eventsourcetype := Trim(GetChunkProperty(CHECKING,"auditedmachinetype"), "Unavailable")
    platformname  := Trim(GetChunkProperty(CHECKING,"SystemName"), "Unavailable")

    case eventsourcetype of
        "13":
            platformtype := "IBM DB2 9.5 on Windows"
            instance_name      := Trim(GetChunkProperty(CHECKING,"Option5"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(CHECKING,"Option1"),"Unavailable")
            inst_patt := Trim(GetChunkProperty(CHECKING,"Option2"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(CHECKING,"Option3"),"Unavailable")
            db_patt := Trim(GetChunkProperty(CHECKING,"Option4"),"Unavailable")
            configpath := Append(instance_name,"\\","security")
        "11":
            platformtype := "IBM DB2 9.5 on AIX"
            instance_name  := Trim(GetChunkProperty(CHECKING,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(CHECKING,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(CHECKING,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(CHECKING,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(CHECKING,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "14":
            platformtype := "IBM DB2 9.5 on SUN"
            instance_name  := Trim(GetChunkProperty(CHECKING,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(CHECKING,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(CHECKING,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(CHECKING,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(CHECKING,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "10":
            platformtype := "IBM DB2 9.5 on HP-UX"
            instance_name  := Trim(GetChunkProperty(CHECKING,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(CHECKING,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(CHECKING,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(CHECKING,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(CHECKING,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "16":
            platformtype := "IBM DB2 9.5 on Linux"
            instance_name  := Trim(GetChunkProperty(CHECKING,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(CHECKING,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(CHECKING,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(CHECKING,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(CHECKING,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        otherwise
            platformtype := "IBM DB2 9.5"
            instance_name  := Trim(GetChunkProperty(CHECKING,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(CHECKING,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(CHECKING,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(CHECKING,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(CHECKING,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
    endcase

/// %Instance name% (if %database% is not defined) or %Instance name%\%database% (if %Object Schema% is not defined) or %Instance name%\%database%:%Object Schema% (otherwise)

    database_name  := Trim(CHECKING.database, "Unavailable")
    object_schema := Trim(CHECKING.object_schema,"Unavailable") 

    case CHECKING.objecttype of
    "DBINSTANCE":
            objectpath := "-"
            objecttype := CHECKING.objecttype
            objectname := instance_name
    "DATABASE":
            objectpath := instance_name
            objecttype := CHECKING.objecttype
            objectname := database_name
    otherwise
        if object_schema eq "Unavailable" 
        then 
            if database_name eq "Unavailable"
            then
                objectpath := instance_name
            else
                objectpath := Append(instance_name,"\\",database_name)
            endif
        else
            objectpath := Append(instance_name,"\\",database_name,":",object_schema)
        endif
            objecttype := Trim(CHECKING.objecttype,"-")
            objectname := Trim(CHECKING.objectname,"-")
    endcase

    object_type := CHECKING.object_type

    object       := GetObject(ObjectRefKey,ObjectAspectKey)    
    origin       := GetOrigin(OriginRefKey)
    platform     := GetPlatform(PlatformRefKey)
    target       := GetTarget(TargetRefKey)

    user_id      := Trim(CHECKING.user_id, "Unavailable")
    if (RegexMatch(user_id,"(.+)\\s$") > "0") then
        user_id      := RegexRef("1")
    endif
    auth_id      := Trim(CHECKING.auth_id, "Unavailable")
    if (auth_id eq "Unavailable")
    then
    auth_id := user_id
    endif

    case eventsourcetype of
        "13":
            logonname  := Uppercase(auth_id)
            realname   := Uppercase(user_id)
            domainname := Trim(GetChunkProperty(CHECKING,"_domain"), "Unavailable")
            domainlogonname  := Uppercase(Append(domainname, "\\", auth_id))
            orig := GetOriginator(domainlogonname,"ND")

            if (orig eq "ND")
            then
                originator := user_id
            else
                originator := orig
                logonname := domainlogonname
            endif
        otherwise
            logonname  := user_id
            realname   := user_id
            rolename   := Uppercase(user_id)
            orig := GetOriginator(logonname,"ND")
            if (orig eq "ND")
            then
                originator := logonname
            else
                originator := orig
            endif
    endcase

    instancename := instance_name

    source     := GetSource(SourceRefKey, SourceAspectKey)
    description := logonname
    stream      := GetStream(StreamRefKey)

    chunk := CHECKING
    eventtimestamp := CHECKING.platformeventtime

    if CHECKING.reason ne ""  then  reason := CHECKING.reason endif
    if CHECKING.attempt ne ""  then  attempt := CHECKING.attempt endif
    if CHECKING.category ne ""  then  category := CHECKING.category endif
    if CHECKING.audit_event ne ""  then  audit_event := CHECKING.audit_event endif
    if CHECKING.nodeid ne ""  then  nodeid := CHECKING.nodeid endif
    if CHECKING.privilege ne ""  then  privilege := CHECKING.privilege endif

    event := GetEvent(EventDetailRefKey)

endstate

/// OBJMAINT

initial final state OBJMAINT 
((    (category eq "OBJMAINT")    
      and (eventmainclass ne "Unavailable")
      and (eventclass ne "Unavailable")
))

     eventmainclass := OBJMAINT.eventmainclass
     eventclass := OBJMAINT.eventclass

    if(OBJMAINT.event_status >= "0")
    then
        successclass := "Success"
    else
        successclass := "Failure"
    endif

    eventsourcetype := Trim(GetChunkProperty(OBJMAINT,"auditedmachinetype"), "Unavailable")
    platformname  := Trim(GetChunkProperty(OBJMAINT,"SystemName"), "Unavailable")

    case eventsourcetype of
        "13":
            platformtype := "IBM DB2 9.5 on Windows"
            instance_name      := Trim(GetChunkProperty(OBJMAINT,"Option5"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(OBJMAINT,"Option1"),"Unavailable")
            inst_patt := Trim(GetChunkProperty(OBJMAINT,"Option2"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(OBJMAINT,"Option3"),"Unavailable")
            db_patt := Trim(GetChunkProperty(OBJMAINT,"Option4"),"Unavailable")
            configpath := Append(instance_name,"\\","security")
        "11":
            platformtype := "IBM DB2 9.5 on AIX"
            instance_name  := Trim(GetChunkProperty(OBJMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(OBJMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(OBJMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(OBJMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(OBJMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "14":
            platformtype := "IBM DB2 9.5 on SUN"
            instance_name  := Trim(GetChunkProperty(OBJMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(OBJMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(OBJMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(OBJMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(OBJMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "10":
            platformtype := "IBM DB2 9.5 on HP-UX"
            instance_name  := Trim(GetChunkProperty(OBJMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(OBJMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(OBJMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(OBJMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(OBJMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "16":
            platformtype := "IBM DB2 9.5 on Linux"
            instance_name  := Trim(GetChunkProperty(OBJMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(OBJMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(OBJMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(OBJMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(OBJMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        otherwise
            platformtype := "IBM DB2 9.5"
            instance_name  := Trim(GetChunkProperty(OBJMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(OBJMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(OBJMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(OBJMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(OBJMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
    endcase

/// %Instance name% (if %database% is not defined) or %Instance name%\%database% (if %Object Schema% is not defined) or %Instance name%\%database%:%Object Schema% (otherwise)

    database_name  := Trim(OBJMAINT.database, "Unavailable")
    object_schema := Trim(OBJMAINT.object_schema,"Unavailable") 

    case OBJMAINT.objecttype of
    "DBINSTANCE":
            objectpath := "-"
            objecttype := Trim(OBJMAINT.objecttype,"-")
            objectname := instance_name
    "DATABASE":
            objectpath := instance_name
            objecttype := Trim(OBJMAINT.objecttype,"-")
            objectname := database_name
    "DBNODEGROUP":
        objecttype := Trim(OBJMAINT.objecttype,"-")
        objectpath := instance_name
        objectname := Trim(OBJMAINT.objectname,"-")
    otherwise
        if object_schema eq "Unavailable" 
        then 
            if database_name eq "Unavailable"
            then
                objectpath := instance_name
            else
                objectpath := Append(instance_name,"\\",database_name)
            endif
        else
            objectpath := Append(instance_name,"\\",database_name,":",object_schema)
        endif
            objecttype := Trim(OBJMAINT.objecttype,"-")
            objectname := Trim(OBJMAINT.objectname,"-")
    endcase

    object       := GetObject(ObjectRefKey,ObjectAspectKey)    

    origin       := GetOrigin(OriginRefKey)
    platform     := GetPlatform(PlatformRefKey)
    target       := GetTarget(TargetRefKey)

    user_id      := Trim(OBJMAINT.user_id, "Unavailable")
    if (RegexMatch(user_id,"(.+)\\s$") > "0") then
        user_id      := RegexRef("1")
    endif
    auth_id      := Trim(OBJMAINT.auth_id, "Unavailable")
    if (auth_id eq "Unavailable")
    then
    auth_id := user_id
    endif

    case eventsourcetype of
        "13":
            logonname  := Uppercase(auth_id)
            realname   := Uppercase(user_id)
            domainname := Trim(GetChunkProperty(OBJMAINT,"_domain"), "Unavailable")
            domainlogonname  := Uppercase(Append(domainname, "\\", auth_id))
            orig := GetOriginator(domainlogonname,"ND")

            if (orig eq "ND")
            then
                originator := user_id
            else
                originator := orig
                logonname := domainlogonname
            endif
        otherwise
            logonname  := user_id
            realname   := user_id
            rolename   := Uppercase(user_id)
            orig := GetOriginator(logonname,"ND")
            if (orig eq "ND")
            then
                originator := logonname
            else
                originator := orig
            endif
    endcase

    instancename := instance_name

    source     := GetSource(SourceRefKey, SourceAspectKey)
    description := logonname
    stream      := GetStream(StreamRefKey)

    chunk := OBJMAINT
    eventtimestamp := OBJMAINT.platformeventtime
    modification2 := Trim(OBJMAINT.modification,"Unavailable")

    case modification2 of
    "Unavailable":
        modification2 := ""
    "ADD_COLUMN_PROTECTION": 
        eventdetail := OBJMAINT.eventdetail
        modification := modification2
    "DROP_COLUMN_PROTECTION": 
        eventdetail := OBJMAINT.eventdetail
        modification := modification2
    otherwise 
        eventdetail := "-"
        modification := modification2
    endcase

    if OBJMAINT.category ne ""  then  category := OBJMAINT.category endif
    if OBJMAINT.audit_event ne ""  then  audit_event := OBJMAINT.audit_event endif
    if OBJMAINT.nodeid ne ""  then  nodeid := OBJMAINT.nodeid endif
    if OBJMAINT.modification ne ""  then  modification := OBJMAINT.modification endif
    if OBJMAINT.eventdetail ne ""  then  eventdetail := OBJMAINT.eventdetail endif

    event := GetEvent(EventDetailRefKey)
endstate

/// SECMAINT

initial state SECMAINT 
((    (category eq "SECMAINT")    
      and (eventmainclass ne "Unavailable")
      and (eventclass ne "Unavailable")
))

     eventmainclass := SECMAINT.eventmainclass
     eventclass := SECMAINT.eventclass

    if(SECMAINT.event_status >= "0")
    then
        successclass := "Success"
    else
        successclass := "Failure"
    endif

    eventsourcetype := Trim(GetChunkProperty(SECMAINT,"auditedmachinetype"), "Unavailable")
    platformname  := Trim(GetChunkProperty(SECMAINT,"SystemName"), "Unavailable")

    case eventsourcetype of
        "13":
            platformtype := "IBM DB2 9.5 on Windows"
            instance_name      := Trim(GetChunkProperty(SECMAINT,"Option5"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SECMAINT,"Option1"),"Unavailable")
            inst_patt := Trim(GetChunkProperty(SECMAINT,"Option2"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SECMAINT,"Option3"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SECMAINT,"Option4"),"Unavailable")
            configpath := Append(instance_name,"\\","security")
        "11":
            platformtype := "IBM DB2 9.5 on AIX"
            instance_name  := Trim(GetChunkProperty(SECMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SECMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SECMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SECMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SECMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "14":
            platformtype := "IBM DB2 9.5 on SUN"
            instance_name  := Trim(GetChunkProperty(SECMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SECMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SECMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SECMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SECMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "10":
            platformtype := "IBM DB2 9.5 on HP-UX"
            instance_name  := Trim(GetChunkProperty(SECMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SECMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SECMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SECMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SECMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "16":
            platformtype := "IBM DB2 9.5 on Linux"
            instance_name  := Trim(GetChunkProperty(SECMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SECMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SECMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SECMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SECMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        otherwise
            platformtype := "IBM DB2 9.5"
            instance_name  := Trim(GetChunkProperty(SECMAINT,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SECMAINT,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SECMAINT,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SECMAINT,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SECMAINT,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
    endcase

/// %Instance name% (if %database% is not defined) or %Instance name%\%database% (if %Object Schema% is not defined) or %Instance name%\%database%:%Object Schema% (otherwise)

    database_name  := Trim(SECMAINT.database, "Unavailable")
    object_schema := Trim(SECMAINT.object_schema,"Unavailable") 

    if SECMAINT.objecttype eq GETOBJ
    then 
        objecttype := Trim(SECMAINT.granteetype,"-")
    else
        objecttype := Trim(SECMAINT.objecttype,"-")
    endif

    if database_name eq "Unavailable"
    then
        objectpath := instance_name
    else
        objectpath := Append(instance_name,"\\",database_name)
    endif

    objectname := Trim(SECMAINT.grantee,"-")

    object_focus := SECMAINT.objectname
    origtype := SECMAINT.objectname

    object       := GetObject(ObjectRefKey,ObjectAspectKey)    

    origin       := GetOrigin(OriginRefKey)
    platform     := GetPlatform(PlatformRefKey)
    target       := GetTarget(TargetRefKey)

    user_id      := Trim(SECMAINT.user_id, "Unavailable")
    if (RegexMatch(user_id,"(.+)\\s$") > "0") then
        user_id      := RegexRef("1")
    endif
    auth_id      := Trim(SECMAINT.auth_id, "Unavailable")
    if (auth_id eq "Unavailable")
    then
    auth_id := user_id
    endif

    case eventsourcetype of
        "13":
            logonname  := Uppercase(auth_id)
            realname   := Uppercase(user_id)
            domainname := Trim(GetChunkProperty(SECMAINT,"_domain"), "Unavailable")
            domainlogonname  := Uppercase(Append(domainname, "\\", auth_id))
            orig := GetOriginator(domainlogonname,"ND")

            if (orig eq "ND")
            then
                originator := user_id
            else
                originator := orig
                logonname := domainlogonname
            endif
        otherwise
            logonname  := user_id
            realname   := user_id
            rolename   := Uppercase(user_id)
            orig := GetOriginator(logonname,"ND")
            if (orig eq "ND")
            then
                originator := logonname
            else
                originator := orig
            endif
    endcase

    instancename := instance_name
    privilege := SECMAINT.privilege

    source     := GetSource(SourceRefKey, SourceAspectKey)
    description := logonname
    stream      := GetStream(StreamRefKey)

    chunk := SECMAINT
    eventtimestamp := SECMAINT.platformeventtime

    if SECMAINT.category ne ""  then  category := SECMAINT.category endif    
    if SECMAINT.audit_event ne ""  then  audit_event := SECMAINT.audit_event endif    
    if SECMAINT.nodeid ne ""  then  nodeid := SECMAINT.nodeid endif    
    if SECMAINT.modification ne ""  then  modification := SECMAINT.modification endif    
    if SECMAINT.eventdetail ne ""  then  eventdetail := SECMAINT.eventdetail endif    
    if SECMAINT.reason ne ""  then  reason := SECMAINT.reason endif    
    if SECMAINT.access_type ne ""  then  access_type := SECMAINT.access_type endif    

    event := GetEvent(EventDetailRefKey)

endstate

/// SYSADMIN

initial state SYSADMIN 
((    (category eq "SYSADMIN") 
      and (eventmainclass ne "Unavailable")
      and (eventclass ne "Unavailable")
))

    eventmainclass := SYSADMIN.eventmainclass

    if(SYSADMIN.event_status >= "0")
    then
        successclass := "Success"
    else
        successclass := "Failure"
    endif

    eventsourcetype := Trim(GetChunkProperty(SYSADMIN,"auditedmachinetype"), "Unavailable")
    platformname  := Trim(GetChunkProperty(SYSADMIN,"SystemName"), "Unavailable")

    case eventsourcetype of
        "13":
            platformtype := "IBM DB2 9.5 on Windows"
            instance_name      := Trim(GetChunkProperty(SYSADMIN,"Option5"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SYSADMIN,"Option1"),"Unavailable")
            inst_patt := Trim(GetChunkProperty(SYSADMIN,"Option2"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SYSADMIN,"Option3"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SYSADMIN,"Option4"),"Unavailable")
            configpath := Append(instance_name,"\\","security")
        "11":
            platformtype := "IBM DB2 9.5 on AIX"
            instance_name  := Trim(GetChunkProperty(SYSADMIN,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SYSADMIN,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SYSADMIN,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SYSADMIN,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SYSADMIN,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "14":
            platformtype := "IBM DB2 9.5 on SUN"
            instance_name  := Trim(GetChunkProperty(SYSADMIN,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SYSADMIN,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SYSADMIN,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SYSADMIN,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SYSADMIN,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "10":
            platformtype := "IBM DB2 9.5 on HP-UX"
            instance_name  := Trim(GetChunkProperty(SYSADMIN,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SYSADMIN,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SYSADMIN,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SYSADMIN,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SYSADMIN,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "16":
            platformtype := "IBM DB2 9.5 on Linux"
            instance_name  := Trim(GetChunkProperty(SYSADMIN,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SYSADMIN,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SYSADMIN,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SYSADMIN,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SYSADMIN,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        otherwise
            platformtype := "IBM DB2 9.5"
            instance_name  := Trim(GetChunkProperty(SYSADMIN,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(SYSADMIN,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(SYSADMIN,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(SYSADMIN,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(SYSADMIN,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
    endcase

    database_name  := Trim(SYSADMIN.database, "Unavailable")

    if SYSADMIN.objecttype eq "DATABASE"
    then
        if (database_name eq "Unavailable")
        then
            if SYSADMIN.eventclass = "DATABASE"
            then
              eventclass := "Dbinstance"
              objecttype := "DBINSTANCE"
              objectpath := "-"
              objectname := instance_name
            else
              eventclass := SYSADMIN.eventclass
              objecttype := "DBINSTANCE"
              objectpath := "-"
              objectname := instance_name
            endif
        else
              eventclass := SYSADMIN.eventclass
              objecttype := "DATABASE"
              objectpath := instance_name
              objectname := database_name
        endif
    else
          eventclass := SYSADMIN.eventclass
          objecttype := Trim(SYSADMIN.objecttype,"DBINSTANCE")
          objectpath := "-"
          objectname := instance_name
    endif
    if SYSADMIN.objecttype eq "SYSTEM"
    then
        objectpath := Trim(GetChunkProperty(SYSADMIN,"SystemName"),"Unavailable")
    endif
    if SYSADMIN.objecttype eq "DBNODE"
    then
        objectpath := instance_name
        objectname := SYSADMIN.nodeid
    endif

      case SYSADMIN.objecttype  of
      "DATABASE":
        if (database_name eq "Unavailable")
        then
            if SYSADMIN.eventclass = "DATABASE"
            then
              eventclass := "Dbinstance"
              objecttype := "DBINSTANCE"
              objectpath := "-"
              objectname := instance_name
            else
              eventclass := SYSADMIN.eventclass
              objecttype := "DBINSTANCE"
              objectpath := "-"
              objectname := instance_name
            endif
        else
              eventclass := SYSADMIN.eventclass
              objecttype := "DATABASE"
              objectpath := instance_name
              objectname := database_name
        endif
      "SYSTEM":
        objectpath := Trim(GetChunkProperty(SYSADMIN,"SystemName"),"Unavailable")
      "DBNODE":
        objectpath := instance_name
        objectname := SYSADMIN.nodeid
      "DBNODEGROUP":
        objectpath := instance_name
        objectname := SYSADMIN.nodeid
      otherwise
              eventclass := SYSADMIN.eventclass
              objecttype := Trim(SYSADMIN.objecttype,"DBINSTANCE")
              objectpath := "-"
              objectname := instance_name

      endcase

    object       := GetObject(ObjectRefKey,ObjectAspectKey)    

    origin       := GetOrigin(OriginRefKey)
    platform     := GetPlatform(PlatformRefKey)
    target       := GetTarget(TargetRefKey)

    user_id      := Trim(SYSADMIN.user_id, "Unavailable")
    if (RegexMatch(user_id,"(.+)\\s$") > "0") then
        user_id      := RegexRef("1")
    endif
    auth_id      := Trim(SYSADMIN.auth_id, "Unavailable")
    if (auth_id eq "Unavailable")
    then
    auth_id := user_id
    endif

    case eventsourcetype of
        "13":
            logonname  := Uppercase(auth_id)
            realname   := Uppercase(user_id)
            domainname := Trim(GetChunkProperty(SYSADMIN,"_domain"), "Unavailable")
            domainlogonname  := Uppercase(Append(domainname, "\\", auth_id))
            orig := GetOriginator(domainlogonname,"ND")

            if (orig eq "ND")
            then
                originator := user_id
            else
                originator := orig
                logonname := domainlogonname
            endif
        otherwise
            logonname  := user_id
            realname   := user_id
            rolename   := Uppercase(user_id)
            orig := GetOriginator(logonname,"ND")
            if (orig eq "ND")
            then
                originator := logonname
            else
                originator := orig
            endif
    endcase

    instancename := instance_name

    source     := GetSource(SourceRefKey, SourceAspectKey)
    description := logonname
    stream      := GetStream(StreamRefKey)

    chunk := SYSADMIN
    eventtimestamp := SYSADMIN.platformeventtime

    if SYSADMIN.category ne ""  then  category := SYSADMIN.category endif    
    if SYSADMIN.audit_event ne ""  then  audit_event := SYSADMIN.audit_event endif    
    if SYSADMIN.nodeid ne ""  then  nodeid := SYSADMIN.nodeid endif    

    event := GetEvent(EventDetailRefKey)

endstate

/// VALIDATE

initial state VALIDATE 
((    (category eq "VALIDATE")    
      and (eventmainclass ne "Unavailable")
      and (eventclass ne "Unavailable")
))

    eventmainclass := VALIDATE.eventmainclass
    eventclass := VALIDATE.eventclass

    if(VALIDATE.event_status >= "0")
    then
        successclass := "Success"
    else
        successclass := "Failure"
    endif

    eventsourcetype := Trim(GetChunkProperty(VALIDATE,"auditedmachinetype"), "Unavailable")
    platformname  := Trim(GetChunkProperty(VALIDATE,"SystemName"), "Unavailable")

    case eventsourcetype of
        "13":
            platformtype := "IBM DB2 9.5 on Windows"
            instance_name      := Trim(GetChunkProperty(VALIDATE,"Option5"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(VALIDATE,"Option1"),"Unavailable")
            inst_patt := Trim(GetChunkProperty(VALIDATE,"Option2"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(VALIDATE,"Option3"),"Unavailable")
            db_patt := Trim(GetChunkProperty(VALIDATE,"Option4"),"Unavailable")
            configpath := Append(instance_name,"\\","security")
        "11":
            platformtype := "IBM DB2 9.5 on AIX"
            instance_name  := Trim(GetChunkProperty(VALIDATE,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(VALIDATE,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(VALIDATE,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(VALIDATE,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(VALIDATE,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "14":
            platformtype := "IBM DB2 9.5 on SUN"
            instance_name  := Trim(GetChunkProperty(VALIDATE,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(VALIDATE,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(VALIDATE,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(VALIDATE,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(VALIDATE,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "10":
            platformtype := "IBM DB2 9.5 on HP-UX"
            instance_name  := Trim(GetChunkProperty(VALIDATE,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(VALIDATE,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(VALIDATE,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(VALIDATE,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(VALIDATE,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        "16":
            platformtype := "IBM DB2 9.5 on Linux"
            instance_name  := Trim(GetChunkProperty(VALIDATE,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(VALIDATE,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(VALIDATE,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(VALIDATE,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(VALIDATE,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
        otherwise
            platformtype := "IBM DB2 9.5"
            instance_name  := Trim(GetChunkProperty(VALIDATE,"Option6"), "Unavailable")
            inst_archpath := Trim(GetChunkProperty(VALIDATE,"Option2"), "Unavailable")
            inst_patt := Trim(GetChunkProperty(VALIDATE,"Option3"),"Unavailable")
            db_archpath := Trim(GetChunkProperty(VALIDATE,"Option4"),"Unavailable")
            db_patt := Trim(GetChunkProperty(VALIDATE,"Option5"),"Unavailable")
            configpath := Append("/home/",instance_name,"/sqllib/security")
    endcase

    database_name  := Trim(VALIDATE.database, "Unavailable")

      objecttype := Trim(VALIDATE.objecttype,"-")
      objectpath := instance_name
      user_id      := Trim(VALIDATE.user_id, "Unavailable")
        if (RegexMatch(user_id,"(.+)\\s$") > "0") then
            user_id      := RegexRef("1")
        endif

    objectname := user_id
    object       := GetObject(ObjectRefKey,ObjectAspectKey)    

    origin       := GetOrigin(OriginRefKey)
    platform     := GetPlatform(PlatformRefKey)
    target       := GetTarget(TargetRefKey)

    auth_id      := Trim(VALIDATE.auth_id, "Unavailable")

    if (auth_id eq "Unavailable")
    then
    auth_id := user_id
    endif

    case eventsourcetype of
        "13":
            logonname  := Uppercase(auth_id)
            realname   := Uppercase(user_id)
            domainname := Trim(GetChunkProperty(VALIDATE,"_domain"), "Unavailable")
            domainlogonname  := Uppercase(Append(domainname, "\\", auth_id))
            orig := GetOriginator(domainlogonname,"ND")

            if (orig eq "ND")
            then
                originator := user_id
            else
                originator := orig
                logonname := domainlogonname
            endif
        otherwise
            logonname  := user_id
            realname   := user_id
            rolename   := Uppercase(user_id)
            orig := GetOriginator(logonname,"ND")
            if (orig eq "ND")
            then
                originator := logonname
            else
                originator := orig
            endif
    endcase

    instancename := instance_name

    source     := GetSource(SourceRefKey, SourceAspectKey)
    description := logonname
    stream      := GetStream(StreamRefKey)

    chunk := VALIDATE
    eventtimestamp := VALIDATE.platformeventtime

    if VALIDATE.category ne ""  then  category := VALIDATE.category endif    
    if VALIDATE.audit_event ne ""  then  audit_event := VALIDATE.audit_event endif    
    if VALIDATE.nodeid ne ""  then  nodeid := VALIDATE.nodeid endif    

    event := GetEvent(EventDetailRefKey)

endstate
